<?php

	/**
	 * Copyright (c) 2020, PacketController Networks
	 * All rights reserved
	 
	 Redistribution and use in source and binary forms, with or without
	 modification, are permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

   3. Neither the name of the PacketController nor the names of its
    contributors may be used to endorse or promote products derived from
    this software without specific prior written permission.
    
   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
	 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	 ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
	 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
	 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	 POSSIBILITY OF SUCH DAMAGE. 
	 
	 * Product: PHP API Client of PacketController
	 * Version: 7.0.6
	 
	 **/
	 
	 class pcapi {
	 			private $conn;
	 		
	 			/**
        * Default Constructor         
        */
        public function __construct($conn){        	
          $this->conn->pcip = $conn->pcip;
          $this->conn->pcport = $conn->pcport;
          $this->conn->user = $conn->user;
          $this->conn->token = $conn->token;
        }
        
        public function execute($args,$GET=true){
        	$args->pcip = $this->conn->pcip;
        	$args->pcport = $this->conn->pcport;
        	$args->user = $this->conn->user;
        	$args->token = $this->conn->token;
        	$curldata = $this->prepareCurl($args,$GET);
        	
        	$URL = $curldata['URL'];
        	if (!$GET) $POSTDATA = $curldata['POSTDATA'];        	
        	
        	$curl = curl_init();
        	curl_setopt($curl, CURLOPT_URL, $URL);
        	curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
        	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
        	curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
        	//We set the POST files
        	if (!$GET) {        		
						curl_setopt($curl, CURLOPT_POST, 1);						
						curl_setopt($curl, CURLOPT_SAFE_UPLOAD, false);        	
        		curl_setopt($curl, CURLOPT_POSTFIELDS, $POSTDATA);
        	}
        	        	
        	$result = curl_exec($curl); 
					$errors = curl_error($curl);
					curl_close($curl);										
					if ($errors!='') throw new Exception($errors);					
					$result = json_decode($result,true);
					//The state: 200 is success while 500 is failure
					if ($result['state']!=200) throw new Exception($result['code']);					
					return $result;
        }
        
        private function prepareCurl($args,$GET){        	      	
        	$return = $postdata = array();        	
        	$baseURL = 'https://'.$args->pcip.':'.$args->pcport.'/api?';
        	$postBaseURL = 'https://'.$args->pcip.':'.$args->pcport.'/api';
        	
        	if ($GET){	        	
	        	foreach ($args as $k=>$v){
	        		if ($k=='pcip' || $k=='pcport') continue;
	        		$baseURL.= $k.'='.urlencode($v).'&'; //We need to encode the space
	        	}
	        	$baseURL.= 'JsonFormat=1';
	        	$return['URL'] = $baseURL;
        	}else{        		        	
	        	$return['URL'] = $postBaseURL;
	        	//Now get post fields
	        	foreach ($args as $k=>$v){	        		
	        		if ($k=='pcip' || $k=='pcport') continue;	        		
	        		$postdata[$k] = $v;
	        	}
	        	$postdata['JsonFormat'] = 1;
	        	$return['POSTDATA'] = $postdata;
        	}        	
        	return $return;
        }
        
		}
	 
?>